class CuClassController {
    
    def index = { redirect(action:list,params:params) }

    // the delete, save and update actions only accept POST requests
    def allowedMethods = [delete:'POST', save:'POST', update:'POST']

    def list = {
        if(!params.max) params.max = 10
        [ cuClassList: CuClass.list( params ) ]
    }

    def show = {
        def cuClass = CuClass.get( params.id )

        if(!cuClass) {
            flash.message = "CuClass not found with id ${params.id}"
            redirect(action:list)
        }
        else { return [ cuClass : cuClass ] }
    }

    def delete = {
        def cuClass = CuClass.get( params.id )
        if(cuClass) {
            cuClass.delete()
            flash.message = "CuClass ${params.id} deleted"
            redirect(action:list)
        }
        else {
            flash.message = "CuClass not found with id ${params.id}"
            redirect(action:list)
        }
    }

    def edit = {
        def cuClass = CuClass.get( params.id )

        if(!cuClass) {
            flash.message = "CuClass not found with id ${params.id}"
            redirect(action:list)
        }
        else {
            return [ cuClass : cuClass ]
        }
    }

    def update = {
        def cuClass = CuClass.get( params.id )
        if(cuClass) {
            cuClass.properties = params
            if(!cuClass.hasErrors() && cuClass.save()) {
                flash.message = "CuClass ${params.id} updated"
                redirect(action:show,id:cuClass.id)
            }
            else {
                render(view:'edit',model:[cuClass:cuClass])
            }
        }
        else {
            flash.message = "CuClass not found with id ${params.id}"
            redirect(action:edit,id:params.id)
        }
    }

    def create = {
        def cuClass = new CuClass()
        cuClass.properties = params
        return ['cuClass':cuClass]
    }

    def save = {
        def cuClass = new CuClass(params)
        if(!cuClass.hasErrors() && cuClass.save()) {
            flash.message = "CuClass ${cuClass.id} created"
            redirect(action:show,id:cuClass.id)
        }
        else {
            render(view:'create',model:[cuClass:cuClass])
        }
    }
}
